/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.service;

import java.util.Map;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.JenisPegawaiDao;
import com.portofolio.dto.JenisPegawaiDto;
import com.portofolio.entity.JenisPegawai;
import com.portofolio.entity.Pendidikan;
import com.portofolio.entity.vo.JenisPegawaiId;
import com.portofolio.exception.InfoException;
import com.portofolio.util.CommonUtil;


@Lazy
@Service
public class JenisPegawaiService extends BaseServiceImpl {

	@Lazy
	@Autowired
	private JenisPegawaiDao jenisPegawaiDao;

	@Lazy
	@Autowired
	private LoginUserService loginUserService;
	
	@Lazy
	@Autowired
	private LanguageService languageService;

	@Transactional
	public Map<String, Object> save(JenisPegawaiDto jenisPegawaiDto) {
		result.clear();
		JenisPegawaiId id = new JenisPegawaiId();
		String kdJenisPegawai =getIdTerahir(JenisPegawai.class.getSimpleName(), 2);
		id.setKdJenisPegawai(kdJenisPegawai);
		id.setKdProfile(getKdProfile());
		JenisPegawai jenisPegawai = CommonUtil.findOne(jenisPegawaiDao, id);
		if (CommonUtil.isNullOrEmpty(jenisPegawai)) {
			jenisPegawai = new JenisPegawai();
			BeanUtils.copyProperties(jenisPegawaiDto, jenisPegawai);
			jenisPegawai.setNoRec(generateUuid32());
			jenisPegawai.setVersion(1);
			jenisPegawai.setId(id);
			jenisPegawai = jenisPegawaiDao.save(jenisPegawai);
			result.put("jenisPegawai", jenisPegawai);
			resultCreated();
		} else {
			throw new InfoException(languageService.getTranslateByKey("jenisPegawai.message.dataAlreadyExist"));
		}

		return result;
	}

	@Transactional
	public Map<String, Object> update(JenisPegawaiDto jenisPegawaiDto, String kdJenisPegawai, Integer version) {
		result.clear();
		JenisPegawaiId id = new JenisPegawaiId();
		id.setKdJenisPegawai(kdJenisPegawai);
		id.setKdProfile(getKdProfile());
		JenisPegawai jenisPegawai = CommonUtil.findOne(jenisPegawaiDao, id);
		if (CommonUtil.isNotNullOrEmpty(jenisPegawai)) {
			if (version < jenisPegawai.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			BeanUtils.copyProperties(jenisPegawaiDto, jenisPegawai);
			jenisPegawai.setVersion(version);
			jenisPegawai = jenisPegawaiDao.save(jenisPegawai);
			result.put("jenisPegawai", jenisPegawai);
			resultUpdated();
		} else {
			resultNotFound();
		}

		return result;
	}

	
	public Map<String, Object> grid(Integer page, Integer limit, String sort, String dir, String namaJenisPegawai,boolean statusEnabled) {
		result.clear();
		page--;
		PageRequest pageReq = PageRequest.of(page, limit, "desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		Page<Map<String, Object>> pageRes;
		if (CommonUtil.isNullOrEmpty(namaJenisPegawai)) {
			pageRes = jenisPegawaiDao.findAllList(getKdProfile(), statusEnabled, pageReq);
		} else {
			pageRes = jenisPegawaiDao.findAllList(getKdProfile(), namaJenisPegawai, statusEnabled, pageReq);
		}
		result.put("jenisPegawai", pageRes.getContent());
		result.put("totalPages", pageRes.getTotalPages());
		result.put("totalRow", pageRes.getTotalElements());
		resultSuccessful();

		return result;
	}

	
	public Map<String, Object> findByKdJenisPegawai(String kdJenisPegawai) {
		result.clear();
		result.put("jenisPegawai", jenisPegawaiDao.findByKdJenisPegawai(getKdProfile(), kdJenisPegawai, CONSTANT_STATUS_ENABLED_TRUE));
		resultSuccessful();
		return result;
	}

	@Transactional
	public Map<String, Object> deleteById(String kdJenisPegawai, Integer version) {
		result.clear();
		JenisPegawaiId id = new JenisPegawaiId();
		id.setKdJenisPegawai(kdJenisPegawai);
		id.setKdProfile(getKdProfile());
		JenisPegawai jenisPegawai = CommonUtil.findOne(jenisPegawaiDao, id);
		if (CommonUtil.isNotNullOrEmpty(jenisPegawai)) {
			if (version < jenisPegawai.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			jenisPegawai.setStatusEnabled(false);
			jenisPegawai.setVersion(version);
			jenisPegawai = jenisPegawaiDao.save(jenisPegawai);
			result.put("jenisPegawai", jenisPegawai);
			resultDeleted();
		} else {
			resultNotFound();
		}

		return result;
	}

	


}
